#[cfg(test)]
mod tests {
    use crate::adder::adder;
    use std::num::Wrapping;

    #[test]
    fn zero_plus_one() {
        assert_eq!(adder(0, 1), 0 + 1);
    }

    #[test]
    fn four_plus_three() {
        assert_eq!(adder(4, 3), 4 + 3);
    }

    #[test]
    fn one_plus_one() {
        assert_eq!(adder(1, 1), 1 + 1);
    }

    #[test]
    fn random_numbers() {
        assert_eq!(adder(632_235, 12_756), 632_235 + 12_756);
        assert_eq!(adder(932_455, 654_756), 932_455 + 654_756);
        assert_eq!(adder(332_875, 123_655), 332_875 + 123_655);
        assert_eq!(adder(732_235_342, 234_756), 732_235_342 + 234_756);
    }

    #[test]
    fn overflow() {
        let big = Wrapping(3_245_532_214u32);
        assert_eq!(adder(3_245_532_214, 3_245_532_214), (big + big).0);
    }
}
